/* PROLOG Version 1.2
Intelligence Software Corp. Copyright 1992, 1993 */

#include "types.h"

int term_cmp( term_ptr t1, term_ptr t2)
{
  int i, cmp = 1;

  if( t1 == NULL || t2 == NULL)
    return 0;
  if( t1 -> type == Functor && t2 -> type == Functor)
    if( strcmp( t1 -> name, t2 ->name) == 0 &&
        t1 -> reps == t2 -> reps)
      for( i = 0; i < t1 -> reps && cmp; i++)
	      cmp = term_cmp( (*t1 -> args)[i], (*t2 -> args)[i]);
    else cmp = 0;
  else
    if( t1 -> type != Functor && t2 -> type != Functor)
      cmp = !strcmp( t1 -> name, t2 ->name);
    else cmp = 0;
  return cmp;
}

int compare( term_ptr s, term_ptr d, list_con *top_con)
{
  int  i, true = 1;

  if(trace)
  {
    puts("\n COMPARISON");
    term_print( s);
    puts(" and ");
    term_print( d);
  }
  if( s == NULL || d == NULL )
    return 0;
  if( s -> type == Atom && d -> type == Atom)
    true = !strcmp( s -> name, d -> name);
  else
    if( s -> type == Functor && d -> type == Functor)
    {
      if( strcmp( s -> name, d -> name) == 0 &&
	  s -> reps == d -> reps)
        for( i = 0; i < s -> reps && true; i++)
	  true = compare((*s -> args)[i], (*d -> args)[i], top_con);
      else true = 0;
    }
    else
      if( s -> type == Variable && d -> type == Variable)
      {
	if( strcmp( s -> name, "_") == 0 ||
	    strcmp( d -> name, "_") == 0)
          true = 1;
        else
	  if((true = agree( s, d, top_con)) == 1)
            *top_con = concret_add( s -> name, d, *top_con);
      }
      else
	if( s -> type == Variable || d -> type == Variable)
        {
	  if( strcmp( s -> name, "_") == 0 ||
	      strcmp( d -> name, "_") == 0) /* invisible variable */
            true = 1;
          else
	  {
	    if( s -> type == Variable)
              true = look_con( s-> name, d, top_con);
            else
	      true = look_con( d-> name, s, top_con);
          }
        }
	else /* s -> type == Functor && d -> type == Atom ||
		s -> type == Atom && d -> type == Functor */
          true = 0;
  return true;
}

list_con concret_add( char *name, term_ptr object, list_con top)
{
  list_con c;

  for( c = top; c != NULL; c = c -> next)
    if( strcmp( name, c -> name) == 0)
      if( term_cmp( c -> object, object))
	return top;
  c = (list_con) alloc( sizeof( struct concret));
  c -> name = (char *) alloc( strlen( name) + 1);
  c -> name = strcpy( c -> name, name);
  c -> object = term_copy( object);
  c -> numb_con = count_put;
  c -> next = top;
  return c;
}

int look_con( char *name, term_ptr mean, list_con *top)
{
  list_con c;
  int good = 1, find = 0;

  for( c = *top; c != NULL && good; c = c -> next)
  {
    if( strcmp( c -> name, name) == 0)
    {
      if( c -> object -> type == Variable)
	good = look_con( c -> object -> name, mean, top);
      else
	good = compare( c -> object, mean, top);
      find = 1;
    }
  }
  if(! find)
    *top = concret_add( name, mean, *top);
  return good;
}

int agree( term_ptr s, term_ptr d, list_con *top)
{
  int conform = 1;
  list_con c, e;

  for( c = *top; c != NULL && conform; c = c -> next)
    if(strcmp( s -> name, c -> name) == 0)
      if(! term_cmp( d, c -> object))
	if( c -> object -> type == Variable)
	  conform = agree( c -> object, d, top);
	else
	  for( e = *top; e != NULL && conform; e = e -> next)
	    if(strcmp( d -> name, e -> name) == 0)
	      if(! term_cmp( s, e -> object))
		if( e -> object -> type == Variable)
		  conform = agree( e -> object, s, top);
		else
		  conform = compare( c -> object,
				     e -> object, top);
  return conform;
}
