/* PROLOG Version 1.2
Intelligence Software Corp. Copyright 1992, 1993 */

#include "types.h"

term_ptr term_copy( term_ptr src_t)
{
  term_ptr cur_t;

  if( src_t == NULL) return NULL;
  cur_t = (term_ptr) alloc( sizeof( struct term));
  cur_t -> name = (char *) alloc( strlen( src_t -> name) + 1);
  cur_t -> name = strcpy( cur_t -> name, src_t -> name);
  cur_t -> type = src_t -> type;
  if( src_t -> type == Functor)
  {
    int i;
    cur_t -> reps = src_t -> reps;
    cur_t -> args = (ar_ptr) alloc( cur_t -> reps * sizeof( term_ptr));
    for( i = 0; i < src_t -> reps; i++)
      (*cur_t -> args)[i] = term_copy((*src_t -> args)[i]);
  }
  else
  {
    cur_t -> reps = 0;
    cur_t -> args = NULL;
  }
  return cur_t;
}

fact_ptr fact_copy( fact_ptr src)
{
  fact_ptr copy = NULL, *cur_fp = &copy;

  for( ; src != NULL; src = src -> next, cur_fp = &(*cur_fp) -> next)
  {
    (*cur_fp) = (fact_ptr) alloc( sizeof( struct fact));
    (*cur_fp) -> term = term_copy( src -> term);
    (*cur_fp) -> next = NULL;
  }
  return copy;
}

sent_ptr sent_copy( sent_ptr src_s)
{
  sent_ptr ret_s;

  if( src_s == NULL) return NULL;
  ret_s = (sent_ptr) alloc( sizeof( struct sentence));
  ret_s -> cuts = src_s -> cuts;
  ret_s -> head = term_copy( src_s -> head);
  ret_s -> body = fact_copy( src_s -> body);
  ret_s -> next = NULL;
  return ret_s;
}

list_con copy_con( list_con src)
{
  list_con copy = NULL, *cur_p = &copy;

  for( ; src != NULL; src = src -> next, cur_p = &(*cur_p) -> next)
  {
    (*cur_p) = (list_con) alloc( sizeof( struct concret));
    (*cur_p) -> name = (char *) alloc( strlen( src -> name) + 1);
    (*cur_p) -> name = strcpy( (*cur_p) -> name, src -> name);
    (*cur_p) -> object = term_copy( src -> object);
    (*cur_p) -> numb_con = src -> numb_con;
    (*cur_p) -> next = NULL;
  }
  return copy;
}

void destroy_sent( sent_ptr dest)
{
  if( dest == NULL) return;
  del_term( dest -> head);
  destroy_fact( dest -> body);
  free( dest);
}

void destroy_fact( fact_ptr dest)
{
  fact_ptr free_fact;

  while( dest != NULL)
  {
    free_fact = dest;
    dest = dest -> next;
    del_term( free_fact -> term);
    free( free_fact);
  }
}

void destroy_con( list_con dest)
{
  list_con con_free;

  while( dest != NULL)
  {
    con_free = dest;
    dest = dest -> next;
    free_con( con_free);
    free( con_free);
  }
}

void destroy_vn( vn_ptr *dest)
{
  vn_ptr free_vn;

  while( *dest != NULL)
  {
    free_vn = *dest;
    *dest = (*dest) -> next;
    free( free_vn -> name);
    free( free_vn -> diffname);
    free( free_vn);
  }
}

void free_con( list_con f)
{
  if( f == NULL) return;
  free( f -> name);
  del_term( f -> object);
}

void del_term( term_ptr fr)
{
  if( fr == NULL) return;
  if( fr -> type == Functor)
  {
    int i;
    for( i = 0; i < fr -> reps; i++)
      del_term((*fr -> args)[i]);
    free( fr -> args);
  }
  free( fr -> name);
  free( fr);
}
