/* PROLOG Version 1.2
Intelligence Software Corp. Copyright 1992, 1993 */

#include "types.h"

void term_print( term_ptr t_ptr)
{
  if( t_ptr == NULL) return;
  if( t_ptr -> type == Variable || t_ptr -> type == Atom)
    printf("%s", t_ptr -> name);
  else
  {
    if( t_ptr -> type == Functor)
    {
      int i = 0, r = t_ptr -> reps;
      printf("%s(", t_ptr -> name);
      for( i = 0; i < r; i++)
      {
        term_print( (*t_ptr -> args)[i]);
        if( i < r - 1)
          printf(",");
      }
    }
    printf(")");
  }
}

void list( sent_ptr top)
{
  fact_ptr f = NULL;

  for( ; top != NULL; top = top -> next)
  {
    term_print( top -> head);
    if( top -> body != NULL)
      if( top -> head != NULL)
        printf(" : - ");
      else
        printf(" ? - ");
    for( f = top -> body; f != NULL; f = f -> next)
    {
      term_print( f -> term);
      if( f -> next != NULL)
        printf(", ");
      else
        printf(".");
    }
    printf("\n");
  }
}

void var_print( char *name, list_con top)
{
  list_con c;

  for( c = top; c != NULL; c = c -> next)
	if( strcmp( c -> name, name) == 0)
	{
	  if( c -> object -> type == Variable)
	    var_print( c -> object -> name, top);
	  else
	    term_print(( c -> object = place( c -> object, top)));
	  return;
	}
  printf("%s", name);
}
