/* PROLOG Version 1.2
Intelligence Software Corp. Copyright 1992, 1993 */

#include "types.h"
#define MAX 120

static char *listname = ".";
static char *listend = "[]";

char analys(char *s)
{
 if( strstr( s,":-") != NULL) return 'r';
 if( strstr( s,"?-") != NULL) return 'q';
 return 'f';
}

int variable(char *string)
{
  if( *string == '_' || isupper( *string) ) return Variable;
  else return Atom;
}

char *get_term( char *src)
{
  char *brk = strchr( src, '(');
  char *spr = strchr( src, ',');
  char *dvn = strchr( src, '|');
  char *end = strchr( src, ')');
  char *lst1 = strchr( src, '[');
  char *lst2 = strchr( src, ']');
  char *ret = NULL;

  if( end == NULL) end = strchr( src, '.');
  if( lst1 != NULL && lst2 != NULL)
  {
    char *l;
    int cnt = 1;

    for( l = lst1 + 1; *l != '\0'; l++)
    {
      if( *l == '[') cnt++;
      if( *l == ']') cnt--;
      if( cnt == 0)
      {
        lst2 = l;
        break;
      }
    }
    while( spr != NULL && spr > lst1 && spr < lst2)
      spr = strchr( spr + 1, ',');
    ret = lst2 + 1;
    if( brk != NULL && brk > lst1 && brk < lst2)
      brk = strchr( ret, '(');
    if( dvn != NULL && dvn > lst1 && dvn < lst2)
      dvn = strchr( ret, '|');
    if( end != NULL && end > lst1 && end < lst2)
      end = strchr( ret, ')');
  }
  if( end == NULL) end = strrchr( src, ']');
  if( spr == NULL) spr = end;
  if( dvn == NULL) dvn = end;
  if( brk == NULL || spr < brk || dvn < brk)
    if( brk == NULL)
      ret = (spr < dvn) ? spr : dvn;
    else
      ret = (spr < brk) ? spr : dvn;
  else
  {
    int cnt_brk = 1;
    char *p;

    for( p = brk + 1; p != NULL; p++)
    {
      if( *p == '(') cnt_brk++;
      if( *p == ')') cnt_brk--;
      if( cnt_brk == 0)
      {
        ret = p + 1;
        break;
      }
    }
    if( p == NULL)
      ret = NULL;
  }
  return ret;
}

int args_cnt( char *first)
{
  int count = 0;
  char *bgn = first, *s = NULL;

  while( bgn != NULL)
  {
    if((s = get_term( bgn)) != NULL)
    {
      if( *s == ',' || *s == ')') count++;
      if( *s == ')') break;
    }
    bgn = s + 1;
  }
  return count;
}

term_ptr term_read( char *src)
{
  char *brk, *s, *dst;
  term_ptr cur;

  if( src == NULL) return NULL;
  cur = (term_ptr) alloc( sizeof( struct term));
  if( *src == '[' && strchr( src, ']') != NULL)
    if( strcmp( src, listend) == 0)
    {
      cur -> name = (char *) alloc( strlen( listend) + 1);
      cur -> name = strcpy(cur -> name, listend);
      cur -> type = Atom;
      cur -> reps = 0;
      cur -> args = NULL;
    }
    else
    {
      free( cur);
      return list_read( src);
    }
  else
    if(( brk = strchr( src,'(')) == NULL)
    {
      cur -> type = variable( src);
      cur -> name = (char *) alloc( strlen( src) + 1);
      cur -> name = strcpy( cur -> name, src);
      cur -> reps = 0;
      cur -> args = NULL;
    }
    else
    {
      int i;

      cur -> type = Functor;
      cur -> name = (char *) alloc( (int)(brk - src) + 1);
      cur -> name = strncpy( cur -> name, src, (int)(brk - src));
      *(cur -> name + (int)(brk - src)) = '\0';
      brk = brk + 1;
      cur -> reps = args_cnt( brk);
      cur -> args = (ar_ptr) alloc( cur -> reps * sizeof( term_ptr));
      for( i = 0; i < cur -> reps; i++)
	      if((dst = get_term( brk)) != NULL)
	      {
          s = (char *) alloc((int)(dst - brk) + 1);
	        s = strncpy( s, brk, (int)(dst - brk));
	        *(s + (int)(dst - brk)) = '\0';
	        (*cur -> args)[i] = term_read( s);
	        free( s);
	        brk = dst + 1;
        }
    }
  return cur;
}

term_ptr list_read( char *src)
{
  term_ptr top = NULL, *cur = &top;
  char *bgn = strchr( src,'[') + 1, *end, *s;

  while(1)
  {
    if(( end = get_term( bgn)) != NULL)
    {
      (*cur) = (term_ptr) alloc( sizeof( struct term));
      (*cur) -> name = (char *) alloc( strlen(listname) + 1);
      (*cur) -> name = strcpy((*cur) -> name, listname);
      (*cur) -> type = Functor;
      (*cur) -> reps = 2;
      (*cur) -> args = (ar_ptr) alloc( 2 * sizeof( term_ptr));
      s = (char *) alloc((int)(end - bgn) + 1);
      s = strncpy( s, bgn, (int)(end - bgn));
      *(s + (int)(end - bgn)) = '\0';
      (*(*cur) -> args)[0] = term_read( s);
      cur = &(*(*cur) -> args)[1];
      free(s);
      bgn = end + 1;
    }
    else
    {
      printf("\n Error in String %s \n", src);
      break;
    }
    if( *end == '|')
    {
      end = get_term( bgn);
      s = (char *) alloc((int)(end - bgn) + 1);
      s = strncpy( s, bgn, (int)(end - bgn));
      *(s + (int)(end - bgn)) = '\0';
      (*cur) = term_read( s);
      free(s);
      break;
    }
    if( *end == ']')
    {
      (*cur) = (term_ptr) alloc( sizeof( struct term));
      (*cur) -> name = (char *) alloc( strlen( listend) + 1);
      (*cur) -> name = strcpy((*cur) -> name, listend);
      (*cur) -> type = Atom;
      (*cur) -> reps = 0;
      (*cur) -> args = NULL;
      break;
    }
  }
  return top;
}

sent_ptr read_sent( char *s, sent_ptr next, char u)
{
  char *p = s, *nxt, *trm;
  sent_ptr top_s = (sent_ptr) alloc( sizeof( struct sentence));
  fact_ptr *fp = &(top_s -> body);

  if( s == NULL) return NULL;
  top_s -> cuts = 0;
  if( u == 'q') top_s -> head = NULL;
  if( u == 'f' || u == 'r')
  {
    while( *s != ':' && *s != '.') s++;
    *s = '\0';
    top_s -> head = term_read( p);
  }
  if( u == 'f') top_s -> body = NULL;
  if( u == 'r' || u == 'q')
  {
    p = (s += 2);	/* :- or ?- */
    while((nxt = get_term( p)) != NULL)
    {
      trm = (char *) alloc((int)(nxt - p) + 1);
      trm = strncpy( trm, p, (int)(nxt - p));
      *(trm + (int)(nxt - p)) = '\0';
      (*fp) = (fact_ptr) alloc( sizeof( struct fact));
      (*fp) -> term = term_read( trm);
      (*fp) -> next = NULL;
      if( strcmp((*fp) -> term -> name, Cut) == 0)
	top_s -> cuts = 1;
      fp = &(*fp) -> next;
      free(trm);
      if( *nxt == '.')
        break;
      p = nxt + 1;
    }
  }
  top_s -> next = next;
  return (top_s);
}

void read_file( char *file)
{
  FILE *f1;
  int i, c;
  char *string, chois, st[MAX];
  sent_ptr *curr_s = &top_l_sent, *curr_q = &top_l_ques;

  top_l_sent = NULL;
  top_l_ques = NULL;
  if(( f1 = fopen( file, "r")) != NULL)
    while((c = getc( f1)) != EOF)
    {
      string = st;
      for( i = 0; c != '.' && i < MAX - 1 && c != EOF; c = getc( f1))
	      if( ! isspace( c))
	{
	  *string++ = c;
		i++;
	}
      if( c == EOF) return;
      *string++ = c;
      *string = '\0';
      if( c != '.')
	      printf("\n String %s is very long \n", st);
      chois = analys( st);
      switch( chois)
      {
	case 'f':
	      case 'r':
	  (*curr_s) = read_sent( st, NULL, chois);
	  curr_s = &(*curr_s) -> next;
	  break;
	case 'q':
	  (*curr_q) = read_sent( st, NULL, chois);
	  curr_q = &(*curr_q) -> next;
	  break;
      }
    }
  else
    printf( "\n Sorry, can't open File %s \n", file);
  fclose(f1);
}
