/* PROLOG Version 1.2
Intelligence Software Corp. Copyright 1992, 1993 */

#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#ifdef MSC
#include <malloc.h>
#else
#include <alloc.h>
#endif

#define PATH 128
#define LINT 5
#define LULONG 10
#define RADIX 10

enum ttype { Functor, Variable, Atom };

typedef struct term *term_ptr;
typedef term_ptr (*ar_ptr)[];
typedef struct fact *fact_ptr;
typedef struct sentence *sent_ptr, *ques_ptr;
typedef struct concret *list_con;
typedef struct varname *vn_ptr;

struct term {
  enum ttype type;
  int reps;
  char *name;
  term_ptr (*args)[];
};

struct fact {
  term_ptr term;
  fact_ptr next;
};

struct sentence {
  int cuts;
  term_ptr head;
  fact_ptr body;
  sent_ptr next;
};

struct concret {
  char *name;
  term_ptr object;
  long int numb_con;
  list_con next;
};

struct varname {
  char *name;
  char *diffname;
  vn_ptr next;
};

void *alloc( size_t size);
void destroy_con( list_con con);
term_ptr place( term_ptr purp, list_con top);
fact_ptr concat( fact_ptr , fact_ptr );
int term_cmp( term_ptr t1, term_ptr t2);
int result( list_con top);
int like( term_ptr sent, term_ptr targ);
int compare(term_ptr src, term_ptr dest, list_con *con);
int compute( sent_ptr top_sent, fact_ptr target, list_con *concr_l, int *cut);
term_ptr term_copy( term_ptr src_t);
sent_ptr sent_copy( sent_ptr src_s);
void var_print( char *name, list_con top);
void term_print( term_ptr t_ptr);
char analys(char *s);
int variable(char *string);
void read_file(char *file);
char *get_term( char *src);
int args_cnt( char *first);
term_ptr term_read( char *src);
term_ptr list_read( char *src);
sent_ptr read_sent( char *s, sent_ptr next, char u);
void free_con( list_con f);
void del_term( term_ptr fr);
char *generate( void);
void diffrent( term_ptr terms, vn_ptr *top);
void destroy_sent( sent_ptr dest);
void destroy_fact( fact_ptr );
void destroy_vn( vn_ptr *);
fact_ptr fact_copy( fact_ptr);
list_con concret_add( char *, term_ptr, list_con);
int look_con( char *, term_ptr, list_con *);
list_con copy_con( list_con src);
void destroy_con( list_con dest);
void list( sent_ptr top);
int agree( term_ptr s, term_ptr d, list_con *top);

extern long count_put;
extern list_con top_l_con;
extern sent_ptr top_l_sent;
extern ques_ptr top_l_ques, cur_ques;
extern char *listname;
extern char *listend;
extern int trace;
extern char *Cut;
