/* PROLOG Version 1.2
Intelligence Software Corp. Copyright 1992, 1993 */

#include "types.h"

int result( list_con top)
{
  list_con c;

  printf("\n");
  for( c = top; c != NULL; c = c -> next)
    if( strstr( c -> name, "__") != c -> name)
    {
      printf("%s", c -> name);
      printf(" = ");
      var_print( c -> name, top);
      printf("\n");
    }
  if(! trace)
    if( getch() == (int) ';') /* Semicolor */
      return 0;
    else
      return 1;
  else
    return 0;
}

char *generate(void)
{
  int l = 0;
  char *string = (char *) alloc(2 + LINT + 1 + LULONG + 1);
  *string = '_';
  *(string + 1) = '_';
  itoa( rand(), string + 2, RADIX);
  l = strlen( string);
  *(string + l) = '\/';
  ultoa( count_put, string + l + 1, RADIX);
  /* free( string + strlen(string) + 1); */
  return string;
}

void diffrent( term_ptr terms, vn_ptr *top)
{
  vn_ptr cur_vn;
  int i;

  if( terms == NULL) return;
  if( terms -> type == Functor)
    for( i = 0; i < terms -> reps; i++)
      diffrent( (*terms -> args)[i], top);
  else
    if( terms -> type == Variable)
      if( strcmp( terms -> name, "_") != 0) /* visible variable */
      {
        for( cur_vn = *top;
             cur_vn != NULL && strcmp( cur_vn -> name, terms -> name) != 0;
             cur_vn = cur_vn -> next) ;
        if( cur_vn == NULL)
        {
          cur_vn = (vn_ptr) alloc(sizeof(struct varname));
          cur_vn -> name = (char *) alloc( strlen( terms -> name) + 1);
          cur_vn -> name = strcpy( cur_vn -> name, terms -> name);
          free( terms -> name);
          terms -> name = generate();
          cur_vn -> diffname = (char *) alloc( strlen(terms -> name) + 1);
          cur_vn -> diffname = strcpy( cur_vn -> diffname, terms -> name);
          cur_vn -> next = *top;
          *top = cur_vn;
        }
        else
        {
          free( terms -> name);
          terms -> name = (char *) alloc( strlen( cur_vn -> diffname) + 1);
          terms -> name = strcpy( terms -> name, cur_vn -> diffname);
        }
      }
}

term_ptr place( term_ptr purp, list_con top)
{
  list_con c;
  int i;
  term_ptr ret = purp;

  if( purp == NULL)
    return NULL;
  if( purp -> type == Functor)
    for( i = 0; i < purp -> reps; i++)
      (*purp -> args)[i] = place( (*purp -> args)[i], top);
  else
    if( purp -> type == Variable)
      if( strcmp( purp -> name, "_") != 0) /* visible variable */
        for( c = top; c != NULL; c = c -> next)
	  if( strcmp( c -> name, purp -> name) == 0)
	      /* && top -> numb_con == count_put) */
          {
	    del_term( purp);
	    ret = term_copy( c -> object);
	    purp = ret = place( ret, top);
          }
  return (ret);
}

fact_ptr concat( fact_ptr body, fact_ptr head)
{
  fact_ptr ptr_f;

  if( body != NULL)
  {
    for( ptr_f = body; ptr_f -> next != NULL; ptr_f = ptr_f -> next);
    ptr_f -> next = head;
    return (body);
  }
  else return (head);
}

void *alloc( size_t size)
{
  void *mem;

  if(( mem = malloc( size)) == NULL) {
    printf("\n Out Of Memory ! \n");
    exit(1);
  }
  return mem;
}